// Head Table
// Copyright 1997 Herbert Duerr

#include "xfstt.h"

HeadTable::HeadTable( RandomAccessFile& f, int offset, int length):
	RandomAccessFile( f, offset, length)
{
	version = readUInt();
	revision = readUInt();
	readUInt();		// checkSumAdjustment
	headMagic = readUInt();
	if( headMagic != HEAD_MAGIC)
		return;		// magic failed !
	flags = readUShort();
	emUnits = readUShort();
	readULong();		// created dateTime: seconds since 1904!!!
	readULong();		// modified dateTime: seconds since 1904!!!
	xmin = readSShort();
	ymin = readSShort();
	xmax = readSShort();
	ymax = readSShort();
	macStyle = readUShort();	// macStyle 1:bold | 2:italic
	lowestPP = readUShort();	// lowestRecPPEM
	readUShort();			// fontDirectionHint 1: left2right
	locaMode = readUShort();	// 0: shortGlyph, 1: longGlyph
	readUShort();			// glyphDataFormat == 0
}

int HeadTable::shortLoca()
{
	return (locaMode == 0);
}

int HeadTable::checkHeadMagic()
{
	return (headMagic == HEAD_MAGIC);
}

