// Character Location Table
// Copyright 1997 Herbert Duerr

#include "xfstt.h"

LocaTable::LocaTable( RandomAccessFile& f, int offset, int length)
:	RandomAccessFile( f, offset, length)
{
}

void LocaTable::setShortFlag( int _isShort)
{
	isShort = _isShort;
}

int LocaTable::getGlyphOffset( int glyphNo)
{
	int o1, o2;
	if( isShort) {
		seekAbsolute( glyphNo << 1);
		o1 = readUShort() << 1;
		o2 = readUShort() << 1;
	} else {
		seekAbsolute( glyphNo << 2);
		o1 = readUInt();
		o2 = readUInt();
	}
	return ((o1!=o2) ? o1 : -1);
}

