// Linear Thresholds for advance width calculation
// Copyright 1997 Herbert Duerr

#include "xfstt.h"

LtshTable::LtshTable( RandomAccessFile& f, int offset, int length)
:	RandomAccessFile( f, offset, length)
{
	/*version = */readUShort();
	numGlyphs = readUShort();
}

int LtshTable::getLinearThreshold( int glyphNo)
{
	if( glyphNo < 0 || glyphNo >= numGlyphs)
		return 0;

	seekAbsolute( 4 + glyphNo);

	int yPel = readUByte();
	dprintf2( "ltsh::getThreshold( glyphNo = %d) = %d\n", glyphNo, yPel);
	return yPel; 
}

