// Name Table
// Copyright 1997 Herbert Duerr

#include "xfstt.h"
#include <string.h>

NameTable::NameTable( RandomAccessFile& f, int offset, int length)
:	RandomAccessFile( f, offset, length)
{
	readUShort();			// format selector == 0
	nRecords = readUShort();
	strBase = readUShort();		// start of string offset
}

char* NameTable::getString( int pfId, int strId, int* len)
{
	// name records
	seekAbsolute( 6);
	// search should be binary
	for( int i = 0; i < nRecords; ++i) {
		// 0: Apple Unicode
		// 1: Macintosh
		// 2: ISO
		// 3: MS encoding
		int platformId = readUShort();

		// 3.0 undefined charset
		// 3.1 UGL charset with unicode indexing
		/*int encodingId = */readUShort();

		/*int languageId = */readUShort();

		// 0: copyright notice
		// 1: font family
		// 2: font subfamily
		// 3: unique font id
		// 4: complete font name
		// 5: version
		// 6: postscript name
		// 7: trademark notice
		int nameId = readUShort();

		int strLength = readUShort();
		int strOffset = readUShort();

		if( platformId == pfId && nameId == strId) {
			char* p = (char*)base + strBase + strOffset;
//			for( int j = 0; j < strLength; ++j)
//				dprintf1( "%c", *(p++));
//			dprintf0( "\n");

			*len = strLength;
			p = (char*)base + strBase + strOffset;
			return p;
		}
	}

	return 0;
}

