// scan line converter
// Copyright 1997 Herbert Duerr

#include "xfstt.h"
extern "C" {
#include "freetype/c/lib/ttraster.h"
}

void Rasterizer::drawContour( int startPoint, int endPoint)
{
	if( startPoint != 0)	// hack... freetype draws all at once
		return;

	static int bufflen = 0;
	if( bufflen == 0) {
		bufflen = 4000;
		void* buffptr = (void*)new U8[ bufflen];
		InitRasterizer( buffptr, bufflen, 0, 0);
		Set_High_Precision( 1);
	}

	TGlyphRecord gr;
	gr.outlines	= nEndPoints;
	gr.points	= nPointsZ1-2;

	gr.outStarts	= new short[ gr.outlines];
	gr.xCoord	= new long[ gr.points];
	gr.yCoord	= new long[ gr.points];
	gr.flag		= new char[ gr.points];

	for( int i = gr.outlines; --i >= 0;)
		gr.outStarts[ i] = endPoints[ i];

	for( int i = gr.points; --i >= 0;) {
		gr.xCoord[ i]	= p[1][i].xnow;
		gr.yCoord[ i]	= ((height - 1) << SHIFT) - p[1][i].ynow;
		gr.flag[ i]	= p[1][i].flags;
	}

	TRasterBlock raster;
	raster.rows	= height;
	raster.cols	= dX;
	raster.width	= width;
	raster.flow	= TT_Flow_Up;
	raster.bitmap	= currBMP;
	raster.size	= length;

	Render_Glyph( &gr, &raster, 2);

	delete[] gr.outStarts;
	delete[] gr.xCoord;
	delete[] gr.yCoord;
	delete[] gr.flag;
}

void Rasterizer::antiAliasing2()
{
}

