#include <afx.h>
#include <afxwin.h>
#include <afxdlgs.h>
//#include <afxext.h>
//#include <afxole.h>
//#include <afxodlgs.h>
//#include <afxdb.h>

#include <stdio.h>

class OutlineApp
: public CWinApp
{
public:
	OutlineApp( void) : CWinApp( "Outline") {}
	
	BOOL InitInstance();

	CFont cfont;
	CStdioFile file;
	DWORD fontSize;
} app;

class OutlineWin
: public CFrameWnd
{
public:
	OutlineWin( void)
	{
		Create( NULL, "Outlines", WS_OVERLAPPEDWINDOW, CRect( 0, 0, 100, 100));
	}
	
	afx_msg void OnPaint( void);

	DECLARE_MESSAGE_MAP()
};


BOOL OutlineApp::InitInstance()
{
	m_pMainWnd = new OutlineWin();

	LPLOGFONT lpfl = new LOGFONT;

	CFontDialog fontdlg;
	if( fontdlg.DoModal() != IDOK)
		return FALSE;
	//fontdlg.GetCurrentFont( lpfl);
    lpfl = fontdlg.m_cf.lpLogFont;
	CString fontName = fontdlg.GetFaceName();
	app.fontSize = fontdlg.GetSize();

	lpfl->lfOutPrecision = OUT_TT_ONLY_PRECIS;	
	lpfl->lfQuality = PROOF_QUALITY;
	cfont.CreateFontIndirect( lpfl);

	CFileDialog filedlg( FALSE, "otl", "font.otl", 0,
		"Outline (*.otl) | *.otl | All Files (*.*) | *.* ||");
	filedlg.DoModal();
	CString pathName = filedlg.GetPathName();
	CString fileName = filedlg.GetFileName();

	file.Open( pathName + fileName,
		CFile::modeCreate | CFile::modeWrite | CFile::typeBinary);

	m_pMainWnd->ShowWindow( m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

BEGIN_MESSAGE_MAP( OutlineWin, CFrameWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void OutlineWin::OnPaint( void)
{
	CPaintDC dc( this);
	dc.SelectObject( &app.cfont);

	CRect rect;
	GetClientRect( rect);
	dc.SetTextAlign( TA_BASELINE | TA_CENTER );
	dc.SetTextColor( ::GetSysColor( COLOR_WINDOWTEXT ) );
	dc.SetBkMode(TRANSPARENT);
	dc.TextOut( (rect.right / 2 ), (rect.bottom / 2), "!@ABCDEF");

	GLYPHMETRICS gm;
	MAT2 mat2 = {{0,1},{0,0},{0,0},{0,1}};
	
	const DWORD BUFSIZE = 32000;
	void* buf = new char[ BUFSIZE];

	app.fontSize *= dc.GetDeviceCaps( LOGPIXELSY) / 72;

	app.file.Write( &app.fontSize, 4);
	for( UINT charNo = 33, zero = 0; charNo <= '}'; ++charNo) {
		DWORD len = dc.GetGlyphOutline( charNo, GGO_NATIVE, &gm, 0, 0, &mat2);
		if( len <= 0 || len > BUFSIZE)
			continue;
		dc.GetGlyphOutline( charNo, GGO_NATIVE, &gm, len, buf, &mat2);
		app.file.Write( &charNo, 2);
		app.file.Write( &zero, 2);
		app.file.Write( &len, 4);
		app.file.WriteHuge( buf, len);
	}
	app.file.Write( "END", 4);
	app.file.Close();
	
	delete buf;
}
